<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Event extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();  
    }
    public function upcomingevents(){
        $date= date('Y-m-d').'T00:00:00Z';
        $api_url = "https://www.googleapis.com/calendar/v3/calendars/ehnklb6fhk0c18ah7564d3d1ls@group.calendar.google.com/events?key=AIzaSyCWKs51_osdAvlkkiYbr7xKCXrfh5uDj1A&timeMin=".$date;
        $ch = curl_init() or die(curl_error());
        curl_setopt($ch, CURLOPT_URL,$api_url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $data = curl_exec($ch);
        $decoded_json = json_decode($data);
        $events = $decoded_json->items;
        $attachments = array();
        $manupulated_events =  array();
        $geocode_array =  array();
        $geocode_cnt = 0;
        foreach ($events as $key => $event) {
            $manupulated_events[$key]['id'] = $event->id;
            $manupulated_events[$key]['status'] = $event->status;
            $manupulated_events[$key]['name'] = $event->summary;
            $manupulated_events[$key]['location'] = $event->location;

          //  echo $event->location; exit;
            if(@$event->start->dateTime){
                $date_time = explode('T', $event->start->dateTime);
                $date = $date_time[0];
                $time_format = explode('+', $date_time[1]);
                $formated_date = $date." ".$time_format[0];
                $myDateTime = DateTime::createFromFormat('Y-m-d H:i:s', $formated_date);
                $formated_date_fn = $myDateTime->format('d M Y H:i:s');
                $start_time = date('h:i A', strtotime($formated_date_fn));
                $start_date = date('D, M d, Y', strtotime($formated_date_fn));
                $manupulated_events[$key]['start_date'] = @$start_date;
                $manupulated_events[$key]['start_time'] = $start_time;
            }else{
                $myDateTime = DateTime::createFromFormat('Y-m-d', @$event->start->date);
                $formated_date_fn = $myDateTime->format('D, M d, Y');
                $manupulated_events[$key]['start_date'] = @$formated_date_fn;
                $manupulated_events[$key]['start_time'] = '';
            }
            if(@$event->end->dateTime){
                $date_time = explode('T', $event->end->dateTime);
                $date = $date_time[0];
                $time_format = explode('+', $date_time[1]);
                $formated_date = $date." ".$time_format[0];
                $myDateTime = DateTime::createFromFormat('Y-m-d H:i:s', $formated_date);
                $formated_date_fn = $myDateTime->format('d M Y H:i:s');
                $end_time = date('h:i A', strtotime($formated_date_fn));
                $end_date = date('D, M d, Y', strtotime($formated_date_fn));
                $manupulated_events[$key]['end_date'] = @$end_date;
                $manupulated_events[$key]['end_time'] = $end_time;
            }else{
                $myDateTime = DateTime::createFromFormat('Y-m-d', @$event->end->date);
                $formated_date_fn = $myDateTime->format('D, M d, Y');
                $manupulated_events[$key]['end_date'] = @$formated_date_fn;
                $manupulated_events[$key]['end_time'] = '';
            }
             $geocode_api = "https://maps.googleapis.com/maps/api/geocode/json?address=".urlencode($event->location)."&key=AIzaSyD_Zq0IxCsxZPSOMdLC-1_JzFmUaxYHlV4";
            $ch = curl_init() or die(curl_error());
            curl_setopt($ch, CURLOPT_URL,$geocode_api);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $data = curl_exec($ch);
            $decoded_json_code = json_decode($data);
            //print_r($decoded_json_code); exit;
            //$formated_date_title = 
            $geocode_array[$key][0] = "<div class='summary'>".@$event->summary.'</div>'.'<br />'.@$start_date."<br /><br />".@$decoded_json_code->results[0]->formatted_address;
            $geocode_array[$key][1] = @$decoded_json_code->results[0]->geometry->location->lat;
            $geocode_array[$key][2] = @$decoded_json_code->results[0]->geometry->location->lng;
            foreach ($event->attachments as $key2 => $attachment) {
                $attachments[$key2]['url']=$attachment->fileUrl;
            }
            $manupulated_events[$key]['attachments'] = $attachments;
        }
        if($manupulated_events){
             $response = array(
                'status' => TRUE,
                'upcoming_events' => $manupulated_events,
                'locations' => $geocode_array
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
     public function pastevents(){
        $date= date('Y-m-d').'T00:00:00Z';
        $api_url = "https://www.googleapis.com/calendar/v3/calendars/ehnklb6fhk0c18ah7564d3d1ls@group.calendar.google.com/events?key=AIzaSyCWKs51_osdAvlkkiYbr7xKCXrfh5uDj1A&timeMax=".$date;
        $ch = curl_init() or die(curl_error());
        curl_setopt($ch, CURLOPT_URL,$api_url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $data = curl_exec($ch);
        $decoded_json = json_decode($data);
        $events = $decoded_json->items;
        $attachments = array();
        $manupulated_events =  array();
        foreach ($events as $key => $event) {
            $manupulated_events[$key]['id'] = $event->id;
            $manupulated_events[$key]['status'] = $event->status;
            $manupulated_events[$key]['name'] = $event->summary;
            $manupulated_events[$key]['location'] = $event->location;
            if(@$event->start->dateTime){
                $date_time = explode('T', $event->start->dateTime);
                $date = $date_time[0];
                $time_format = explode('+', $date_time[1]);
                $formated_date = $date." ".$time_format[0];
                $myDateTime = DateTime::createFromFormat('Y-m-d H:i:s', $formated_date);
                $formated_date_fn = $myDateTime->format('d M Y H:i:s');
                $start_time = date('h:i A', strtotime($formated_date_fn));
                $start_date = date('D, M d, Y', strtotime($formated_date_fn));
                $manupulated_events[$key]['start_date'] = @$start_date;
                $manupulated_events[$key]['start_time'] = $start_time;
            }else{
                $myDateTime = DateTime::createFromFormat('Y-m-d', @$event->start->date);
                $formated_date_fn = $myDateTime->format('D, M d, Y');
                $manupulated_events[$key]['start_date'] = @$formated_date_fn;
                $manupulated_events[$key]['start_time'] = '';
            }
            if(@$event->end->dateTime){
                $date_time = explode('T', $event->end->dateTime);
                $date = $date_time[0];
                $time_format = explode('+', $date_time[1]);
                $formated_date = $date." ".$time_format[0];
                $myDateTime = DateTime::createFromFormat('Y-m-d H:i:s', $formated_date);
                $formated_date_fn = $myDateTime->format('d M Y H:i:s');
                $end_time = date('h:i A', strtotime($formated_date_fn));
                $end_date = date('D, M d, Y', strtotime($formated_date_fn));
                $manupulated_events[$key]['end_date'] = @$end_date;
                $manupulated_events[$key]['end_time'] = $end_time;
            }else{
                $myDateTime = DateTime::createFromFormat('Y-m-d', @$event->end->date);
                $formated_date_fn = $myDateTime->format('D, M d, Y');
                $manupulated_events[$key]['end_date'] = @$formated_date_fn;
                $manupulated_events[$key]['end_time'] = '';
            }
            foreach ($event->attachments as $key2 => $attachment) {
                $attachments[$key2]['url']=$attachment->fileUrl;
            }
            $manupulated_events[$key]['attachments'] = $attachments;
        }
        if($manupulated_events){
             $response = array(
                'status' => TRUE,
                'past_events' => $manupulated_events
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_event_subtype(){
    	$this->db->select('ActivitySubtypeID as id, SubTypeName as name');
        $this->db->where('Ptsl_ActivityType_ActivityTypeID',2);
    	$data = $this->db->get('ptsl_activitysubtype')->result_array();
    	if($data){
             $response = array(
                'status' => TRUE,
                'event_subtypes' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_account_event(){
    	$this->db->select('AccountID as id,LongName as name');
    	$data = $this->db->get('ptsl_accountinfo')->result_array();
    	if($data){
             $response = array(
                //'status' => TRUE,
                'users' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function addevent(){
    	$post_data = json_decode(file_get_contents('php://input'), true);
        //print_r($post_data);
        //echo json_encode($post_data);  return;
    	//$Buyer = @$post_data['buyer'];
    	//$spokewith = @$post_data['spokewith'];
    	$InternalNotes = @$post_data['internal_note'];
    	$notes = @$post_data['note'];
    	$BrandExposure = @$post_data['brand'];
    	$CreatedBy = @$post_data['user_id'];
    	$Client_Rep_ID = @$post_data['user_id'];
    	$CreatedDate = date('Y-m-d');
    	$event_name = @$post_data['event_name'];
    	//$ActivityImage = @$post_data['image'];
    	//$ptsl_activitySubtype_ActivitySubtypeID = @$post_data['subtype'];
        $subtype = @$post_data['subtype'];
    	$idAcc = @$post_data['account_id'];
        $participants = @$post_data['participants'];
        if($idAcc){
            $ptsl_accountinfo_AccountID = @$idAcc['id'];
        }
        if($subtype){
            $ptsl_activitySubtype_ActivitySubtypeID = $subtype;
        }
        else{
            $ptsl_activitySubtype_ActivitySubtypeID = 0;
        } 
        
        $isEvent =1;
        	
        if(!$ptsl_activitySubtype_ActivitySubtypeID){
        	$response = array(
        		'status' => FALSE,
        		'message'=> "Event Type is required"
        	);
        	echo json_encode($response);
        	return;
        }else{
	
        	$ActivityDate = date('Y-m-d');
        	$data = array(
        		//'ActivityTypeID' => $ActivityTypeID,
        		'InternalNotes'  => $InternalNotes,
        		'Notes'          => $notes,
        		'BrandExposure'  => $BrandExposure,
        		'CreatedBy'      => $CreatedBy,
        		'CreatedDate'    => $CreatedDate,
        		'ActivityDate'	 => $ActivityDate,	
        		'isEvent' => $isEvent,
        		'EventName' => $event_name,		
        		//'ActivityImage'  => $ActivityImage,
        		'ptsl_activitySubtype_ActivitySubtypeID'=> $ptsl_activitySubtype_ActivitySubtypeID,
        		'AccountID' => @$ptsl_accountinfo_AccountID
        	);
        	$add_activity = $this->db->insert('ptsl_account_activity',$data);
        	$acitivity_id = $this->db->insert_id();

        	//participants
            if($participants){
                foreach($participants as $participant){
                    if(@$participant['selected'] == 1){
                        $data2= array(
                            'ActivityID' => $acitivity_id,
                            'ParticipantID' => $participant['id']
                        );
                        $res = $this->db->insert('ptsl_activity_participants',$data2);
                    }

                }
            }
        	
        	
            if(@$post_data['photos']){    
                $images = $post_data['photos'];
                foreach ($images as $key => $image) {
                    //create thum
                    $loc="../accountapi_dev/temp/img".date('YmdHis');
                    $imgData1 = $image;
                    $imgData1 = substr($imgData1, 1+strrpos($imgData1, ','));
                    $sourceFilename = 'http://periscopedemo.com/accountapi_dev/temp/imgMyFile.jpg';
                    file_put_contents($loc.'MyFile.jpg', base64_decode($imgData1));
                    $image_file=$loc.'MyFile.jpg';
                    $target_file = $image_file;
                    $thumbnail = "../accountapi_dev/thumb/".date('YmdHis')."file.jpg";
                    $wthumb = 100;
                    $hthumb = 100;
                    $fileExt="jpg";
                    $this->ak_img_thumb($target_file, $thumbnail, $wthumb, $hthumb, $fileExt);
                    $encoded_thumb = base64_encode(file_get_contents($thumbnail));
                    $jpg_encoded_thumb = "data:image/jpeg;base64,".$encoded_thumb;    
                    $data_img = array(
                            'ActivityID' => $acitivity_id,
                            'Photo' => $image,
                            'thumbnail' => $jpg_encoded_thumb
                        );
                    $res = $this->db->insert('ptsl_activity_photos',$data_img); 
                }
            }
        	if($add_activity){
        		$response = array(
        			'status' => TRUE,
                    'event_id'=>$acitivity_id,
        			'message'=> "Event Inserted Successfully"
        		);
        		echo json_encode($response);
        	}
        	else{
        		$response = array(
        			'status' => FALSE,
        			'message'=> "Internal Error"
        		);
        		echo json_encode($response);	
        	}
        }
    }
     public function updateevent(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        
        //$Buyer = @$post_data['buyer'];
        //$spokewith = @$post_data['spokewith'];
        $InternalNotes = @$post_data['internal_note'];
        $notes = @$post_data['note'];
        $BrandExposure = @$post_data['brand'];
        $CreatedBy = @$post_data['user_id'];
        $Client_Rep_ID = @$post_data['user_id'];
        $CreatedDate = date('Y-m-d');
        $event_name = @$post_data['event_name'];
        //$ActivityImage = @$post_data['image'];
        $ptsl_activitySubtype_ActivitySubtypeID = @$post_data['subtype'];
        $idAcc = @$post_data['account_id'];
        $event_id = $post_data['event_id'];
        $activity_id = $event_id;
        if($idAcc){
            $ptsl_accountinfo_AccountID = @$idAcc['id'];
        }else{
            $ptsl_accountinfo_AccountID = '';
        } 
        
        //multiple accout rep id 
        $participants = @$post_data['participants'];
        //$ptsl_activitySubtype_ActivitySubtypeID = 1;
        $isEvent =1;
        
        /*if(!$ptsl_activitySubtype_ActivitySubtypeID){
            $response = array(
                'status' => FALSE,
                'message'=> "Event Type is required"
            );
            echo json_encode($response);
            return;
        }*/
        
        $ActivityDate = date('Y-m-d');
        $data = array(
            'CreatedBy'      => $CreatedBy,
            'CreatedDate'    => $CreatedDate,
            'ActivityDate'   => $ActivityDate,  
            'isEvent' => $isEvent,

        );
        if(@$ptsl_accountinfo_AccountID){
            //array_push($data, var)
            $data['AccountID'] = $ptsl_accountinfo_AccountID;
        }
        if(@$ptsl_activitySubtype_ActivitySubtypeID){
            $data['ptsl_activitySubtype_ActivitySubtypeID']= $ptsl_activitySubtype_ActivitySubtypeID;
        }
        if(@$event_name){
            $data['EventName'] = $event_name;
        }
        if(@$InternalNotes){
            $data['InternalNotes'] = $InternalNotes;
        }
        if(@$notes){
            $data['Notes'] = $notes;
        }
        if(@$BrandExposure){
            $data['BrandExposure'] = $BrandExposure; 
        }
        $this->db->where('ActivityID',$event_id);
        $add_activity = $this->db->update('ptsl_account_activity',$data);
        if($participants){
            $this->db->where('ActivityID',$event_id);
            $this->db->delete('ptsl_activity_participants');
            foreach($participants as $participant){
                if(@$participant['selected'] == 1){
                    $data2= array(
                        'ActivityID' => $event_id,
                        'ParticipantID' => $participant['id']
                    );
                    $res = $this->db->insert('ptsl_activity_participants',$data2);
                }

            }
        }
        if(@$post_data['photos']){    
            $images = $post_data['photos'];
            foreach ($images as $key => $image) {
                $loc="../accountapi_dev/temp/img".date('YmdHis');
                $imgData1 = $image;
                $imgData1 = substr($imgData1, 1+strrpos($imgData1, ','));
                $sourceFilename = 'http://periscopedemo.com/accountapi_dev/temp/imgMyFile.jpg';
                file_put_contents($loc.'MyFile.jpg', base64_decode($imgData1));
                $image_file=$loc.'MyFile.jpg';
                $target_file = $image_file;
                $thumbnail = "../accountapi_dev/thumb/".date('YmdHis')."file.jpg";
                $wthumb = 100;
                $hthumb = 100;
                $fileExt="jpg";
                $this->ak_img_thumb($target_file, $thumbnail, $wthumb, $hthumb, $fileExt);
                $encoded_thumb = base64_encode(file_get_contents($thumbnail));
                $jpg_encoded_thumb = "data:image/jpeg;base64,".$encoded_thumb; 
                $data_img = array(
                        'ActivityID' => $event_id,
                        'Photo' => $image,
                        'thumbnail' => ''
                    );
                $res = $this->db->insert('ptsl_activity_photos',$data_img); 
            }
        }
        if($add_activity){
            $response = array(
                'status' => TRUE,
                //'event_id'=>$acitivity_id,
                'message'=> "Event Updated Successfully"
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message'=> "Internal Error"
            );
            echo json_encode($response);    
        }
    }
     public function get_event_details($id){
        $this->db->select('acc.LongName,stype.Ptsl_ActivityType_ActivityTypeID,acc.AccountID,act.ActivityID,stype.SubTypeName,act.EventName,act.Buyer,act.spokewith,act.InternalNotes,act.Notes,act.ActivityDate,act.BrandExposure,act.DecisionMaker,act.BestTimeToVisit');
        $this->db->from('ptsl_account_activity act');
        $this->db->join('ptsl_accountinfo acc','acc.AccountID = act.AccountID','left');
        //$this->db->join('ptsl_activitytype as type','act.ActivityTypeID=type.ActivityTypeID','');
        $this->db->join('ptsl_activitysubtype as stype','act.ptsl_activitySubtype_ActivitySubtypeID=stype.ActivitySubtypeID','');
        //$this->db->join('ptsl_activity_photos',);
        $this->db->where('act.ActivityID',$id);
        //$this->db->where('stype.Ptsl_ActivityType_ActivityTypeID',2);
        $data['activity'] = $this->db->get()->row();
        if($data){
            $this->db->select('rep.ClientRepName as name,par.ParticipantID');
            $this->db->join('ptsl_clientrep rep','rep.ClientRepID = par.ParticipantID');
            $this->db->where('par.ActivityID',$id);
            $participants = $this->db->get('ptsl_activity_participants par')->result_array();
            //$data['photos'] = $photos;
            $data['participants'] = $participants;
             $this->db->select('photos.thumbnail,photos.PhotoID');
             $this->db->from('ptsl_activity_photos photos');
            // $this->db->join('ptsl_activity_photos photos','act.ActivityID=photos.ActivityID','');
             $this->db->where('photos.ActivityID',$id);
             $this->db->where('photos.thumbnail!=""');
             $data_photos = $this->db->get()->result_array();
             $new_array = array(); 
             foreach($data_photos as $key=>$adata){
                 $new_array[$key]['id'] =$key;
                 $new_array[$key]['src'] = $adata['thumbnail'];
                 $new_array[$key]['PhotoID'] =$adata['PhotoID'];
             }
             $data['photos'] = $new_array;
             $response = array(
                'status' => TRUE,
                'activity' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function getPhotosidbyActivityid($id){
        $this->db->select('p.PhotoID');
        //$this->db->where('PhotoID',$photoid);
        $this->db->from('ptsl_activity_photos p');
        $this->db->join('ptsl_account_activity a','p.ActivityID=a.ActivityID','');
        $this->db->where('a.ActivityID',$id);
        $this->db->where('p.thumbnail!=""');
        $data = $this->db->get()->result_array();
        if($data){
          $response= array(
                'status' => TRUE,
                'photos_id' => $data  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
      public function get_event_details_edit($id){
        $this->db->select('acc.LongName,stype.Ptsl_ActivityType_ActivityTypeID,acc.AccountID,act.ActivityID,stype.SubTypeName,act.EventName,act.Buyer,act.spokewith,act.InternalNotes,act.Notes,act.ActivityDate,act.BrandExposure,act.DecisionMaker,act.BestTimeToVisit');
        $this->db->from('ptsl_account_activity act');
        $this->db->join('ptsl_accountinfo acc','acc.AccountID = act.AccountID','left');
        //$this->db->join('ptsl_activitytype as type','act.ActivityTypeID=type.ActivityTypeID','');
        $this->db->join('ptsl_activitysubtype as stype','act.ptsl_activitySubtype_ActivitySubtypeID=stype.ActivitySubtypeID','');
        //$this->db->join('ptsl_activity_photos',);
        $this->db->where('act.ActivityID',$id);
        //$this->db->where('stype.Ptsl_ActivityType_ActivityTypeID',2);
        $data['activity'] = $this->db->get()->row();
        if($data){
          //  $this->db->select('photo');
           // $this->db->where('ActivityID',$id);
           // $photos = $this->db->get('ptsl_activity_photos')->result_array();
            $this->db->select('rep.ClientRepName as name,par.ParticipantID');
            $this->db->join('ptsl_clientrep rep','rep.ClientRepID = par.ParticipantID');
            $this->db->where('par.ActivityID',$id);
            $participants = $this->db->get('ptsl_activity_participants par')->result_array();
            $part_names = "";
            foreach($participants as $participant){
                $part_names = $part_names.$participant['name'].", ";
            }
            $selected_part_name = trim($part_names, ',');
            $data['par_names'] = $selected_part_name;
            $data['participants'] = $participants;
             $response = array(
                'status' => TRUE,
                'activity' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function test($id){
        $this->db->select('thumbnail');
        $data = $this->db->get_where('ptsl_activity_photos',array('PhotoID'=>$id))->result_array();
        $img = $data[0]['thumbnail'];
        echo '<img src="'.$img.'" />';
    }
    private function ak_img_thumb($target, $newcopy, $w, $h, $ext) {
        list($w_orig, $h_orig) = getimagesize($target);
        $src_x = ($w_orig / 2) - ($w / 2);
        $src_y = ($h_orig / 2) - ($h / 2);
        $ext = strtolower($ext);
        $img = "";
        if ($ext == "gif"){ 
        $img = imagecreatefromgif($target);
        } else if($ext =="png"){ 
        $img = imagecreatefrompng($target);
        } else { 
        $img = imagecreatefromjpeg($target);
        }
        $tci = imagecreatetruecolor($w, $h);
        //imagecopyresampled($tci, $img, 0, 0, $src_x, $src_y, $w, $h, $w_orig, $h_orig);
        imagecopyresampled($tci, $img, 0, 0, 0, 0, $w, $h, $w_orig, $h_orig);
        if ($ext == "gif"){ 
            imagegif($tci, $newcopy);
        } else if($ext =="png"){ 
            imagepng($tci, $newcopy);
        } else { 
           $t= imagejpeg($tci, $newcopy, 84);
           //echo base64_encode($t);

        }
       //echo base64_encode($target);
    }
    
}