<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Map extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();  
    }
    public function accounts(){
       /* $this->db->select('AccountID,LongName,Address,state,City,Zipcode');
        $this->db->limit(1000,0);
        $accounts = $this->db->get('ptsl_accountinfo')->result_array();*/
        $sql = "SELECT * FROM `ptsl_accountinfo_copy` WHERE latitude ='' ";
        $accounts = $this->db->query($sql)->result_array();
      //  echo $this->db->last_query(); exit;
        $manupulated_account =  array();
        $geocode_array =  array();
        $geocode_cnt = 0;
        foreach ($accounts as $key => $account) {
            $location = $account['Address']." ".$account['state']." ".$account['City']." ".$account['Zipcode'];
            $manupulated_account[$key]['address'] = $location;
            $href = 'clientresult/'.$account['AccountID'];
            $href_text = '<a href="'.$href.'">Go to Account</a>';
            $geocode_api = "https://maps.googleapis.com/maps/api/geocode/json?address=".urlencode($location)."&key=AIzaSyCrSTMmRS8md20ncxVjnQtknZZfaaUwRnQ";
            //echo  $geocode_api; exit;
            $ch = curl_init() or die(curl_error());
            curl_setopt($ch, CURLOPT_URL,$geocode_api);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $data = curl_exec($ch);
           // print_r($data);
            $decoded_json_code = json_decode($data);
          //  print_r($decoded_json_code);
            //$formated_date_title = 
           // $geocode_array[$key][0] = "<div class='summary'>".$account['LongName'].'</div>'.'<br />'.$location."<br /><br />".$href_text;
           // $geocode_array[$key][1] = @$decoded_json_code->results[0]->geometry->location->lat;
           // $geocode_array[$key][2] = @$decoded_json_code->results[0]->geometry->location->lng;
            $latlongarray = array(
                'latitude' => @$decoded_json_code->results[0]->geometry->location->lat,
                'longitude'=> @$decoded_json_code->results[0]->geometry->location->lng
            );
            $this->db->where('AccountID',$account['AccountID']);
            $this->db->update('ptsl_accountinfo_copy',$latlongarray);
        }
        if(@$geocode_array){
             $response = array(
                'status' => TRUE,
                'locations' => $geocode_array
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function accounts_info(){
    	$this->db->select('AccountID,LongName,latitude,longitude,Address,City,state,Zipcode');
        $geocode_array = array();
        $accounts = $this->db->get('ptsl_accountinfo')->result_array();
        $cnt = 0;
        $len=count($accounts);
        foreach ($accounts as $key => $account) {
            if($account['latitude']){
                $address = $account['Address'].' '.$account['City'].' '.$account['state'].' '.$account['Zipcode'];
                $name = $account['LongName'];
                $link = '<div class="sum2">'.'<a href="#/clientresult/'.$account["AccountID"].'">Go to Account</a></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
            }
        }
         if(@$accounts){
             $response = array(
                'status' => TRUE,
                'locations' => $geocode_array,
                'len' => $len
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function accounts_info_filter(){
        $this->db->select('AccountID,LongName,latitude,longitude,Address,City,state,Zipcode');
        $this->db->limit(1,0);
        $geocode_array = array();
        $accounts = $this->db->get('ptsl_accountinfo')->result_array();
        $cnt = 0;
        $len=count($accounts);
        foreach ($accounts as $key => $account) {
            if($account['latitude']){
                $address = $account['Address'].' '.$account['City'].' '.$account['state'].' '.$account['Zipcode'];
                $name = $account['LongName'];
                $link = '<div class="sum2">'.'<a href="#/clientresult/'.$account["AccountID"].'">Go to Account</a></div>';
              //  echo $link; exit;
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
            }
        }
         if(@$accounts){
             $response = array(
                'status' => TRUE,
                'locations' => $geocode_array,
                'len' => $len
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    } 
    public function get_account_status(){
        $this->db->select('*');
        $data = $this->db->get('ptsl_accountstatus')->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'accounts_status' => $data
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => False,
                'message'=>'No data Found'
            );
            echo json_encode($response);
        }
    } 
    public function get_account_type(){
        $this->db->select('*');
        $data = $this->db->get('ptsl_accounttype')->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'error_code' =>200,
                'accounts_type' => $data
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => False,
                'error_code'=> 404,
                'message'=>'No data Found'
            );
            echo json_encode($response);
        }
    }

    public function get_filter_data(){
        $status  = @$this->input->get('status_id');
        $type    = @$this->input->get('type_id');
        $state      = @$this->input->get('state');
        $zipcode    = @$this->input->get('zip');
        $status_id ="";
        $type_id="";
        if($status){
           $data_status = $this->db->get_where('ptsl_accountstatus',array('AccountStatusName'=>$status))->result_array();
           @$status_id = $data_status[0]['AccountStatusID'];
        }
        if($type){
           $data_type = $this->db->get_where('ptsl_accounttype',array('AccountTypeName'=>$type))->result_array();
           @$type_id = $data_type[0]['AccountTypeID'];
        }
        $this->db->select('AccountID,LongName,latitude,longitude,Address,City,state,Zipcode');
        $this->db->from('ptsl_accountinfo info');
        $this->db->join('ptsl_accounttype type','type.AccountTypeID = info.ptsl_accounttype_AccountTypeID','');
        $this->db->join('ptsl_accountstatus status','status.AccountStatusID=info.ptsl_accountstatus_AccountStatusID','');
        if($status_id){
            $this->db->where('status.AccountStatusID',$status_id);
        }
        if($type_id){
            $this->db->where('type.AccountTypeID',$type_id);
        }
        if($state){
            $this->db->where('info.state',$state);
        }
        if($zipcode){
            $this->db->where('info.Zipcode',$zipcode);
        }
        $accounts = $this->db->get()->result_array();
        $geocode_array = array();
        $cnt = 0;
        $len=count($accounts);
        foreach ($accounts as $key => $account) {
            if($account['latitude']){
                $address = $account['Address'].' '.$account['City'].' '.$account['state'].' '.$account['Zipcode'];
                $name = $account['LongName'];
                $link = '<div class="sum2">'.'<a href="#/clientresult/'.$account["AccountID"].'">Go to Account</a></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
            }
        }
         if(@$accounts){
             $response = array(
                'status' => TRUE,
                'locations' => $geocode_array,
                'len' => $len
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }


































}