<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class User extends CI_Controller {
	public function __construct() 
    {
        parent::__construct();
        if(!$this->session->userdata("userdata")) {
            redirect(base_url());
            // do something
        }
    }
	public function index(){
		$this->db->select('*');
		$this->db->order_by('id','desc');
		$data['users'] = $this->db->get('users')->result_array();
		$data['heading_title']="Users";
		$this->load->view('header',$data);
		$this->load->view('navbar');
		$this->load->view('users');
		$this->load->view('footer');

	}
	public function create(){
		$data=array('heading_title' => 'Create User');
		$this->load->view('header',$data);
		$this->load->view('navbar');
		$this->load->view('create_user');
		$this->load->view('footer');

	}
	public function edit($id){
		$this->db->where('id',$id);
		$user = $this->db->get('users')->result_array();
		$data['id'] =$user[0]['id'];
		$data['fullname']=$user[0]['fullname'];
		$data['username']=$user[0]['username'];
		$data['email']=$user[0]['email'];
		$data['phone']=$user[0]['phone'];
		$data['location']=$user[0]['location'];
		$data['heading_title'] = 'Edit User';
		$this->load->view('header',$data);
		$this->load->view('navbar');
		$this->load->view('edit_user');
		$this->load->view('footer');

	}

	public function update($id){
		
		
				$this->db->where('email',$this->input->post('email'));
				$is_email_exsists = $this->db->get('users')->result_array();
				
					$user_data = $this->session->userdata('userdata');
					$user_id= $user_data['id'];
					$data = array(
							'fullname' => $this->input->post('fullname'),
							'username' => $this->input->post('username'),
							'password' => md5($this->input->post('password')),
							//'email'	   => $this->input->post('email'),
							//'phone'    => $this->input->post('phone'),
							'location' => $this->input->post('location'),
							'created_by'=>$user_id	 	
						);
					$this->db->where('id',$id);
					$result=$this->db->update('users',$data);
					if($result){
						$this->session->set_flashdata('create_user_data_success','User Updated Successfully');
						redirect('/user/edit/'.$id);
					}
			
		
	}
	public function add_user(){

		$this->db->select('*');
		$this->db->where('phone',$this->input->post('phone'));
		$data = $this->db->get('users')->result_array();
		if($data){
			$this->session->set_flashdata('create_user_data_error_phone','Phone already exits');
			redirect('/user/create');
		}
		else{
			$this->db->where('email',$this->input->post('email'));
			$is_email_exsists = $this->db->get('users')->result_array();
			
			if(!$is_email_exsists){
				$user_data = $this->session->userdata('userdata');
				 //var_dump($user_data);
				$user_id= $user_data['user_id'];
				$data = array(
					'username' => $this->input->post('username'),
					'password' => md5($this->input->post('password')),
					'fullname' => $this->input->post('fullname'),
					'email'    => $this->input->post('email'),
					'phone'    =>$this->input->post('phone'),
					'location' =>$this->input->post('location'),
					'created_by'=> $user_id
				);
				$result = $this->db->insert('users',$data);
				if($result){
					$this->session->set_flashdata('create_user_data_success','User Created Successfully');
					redirect('/user/create');
				}
			}
			else{
				$this->session->set_flashdata('create_user_data_error_email','Email already exits');
				redirect('/user/create');
			}
			
		}
	}
	public function delete($id){
		$this->db->where('id',$id);
		$result=$this->db->delete('users')->result_array();
		if($result){
			redirect('/users/index');
		}

	}
}