<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Account_photos extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();
        
    }
    public function index($id){
    	$this->db->select('LongName');
    	$data_name = $this->db->get_where('ptsl_accountinfo', array('AccountID'=>$id))->result_array();
    	$account_name = $data_name[0]['LongName'];
    	$this->db->select('act.ActivityID ,photos.thumbnail,photos.PhotoID');
    	$this->db->from('ptsl_account_activity act');
    	$this->db->join('ptsl_activity_photos photos','act.ActivityID=photos.ActivityID','');
    	$this->db->where('act.AccountID',$id);
    	$this->db->where('photos.thumbnail!=""');
    	$data = $this->db->get()->result_array();
        $new_array = array(); 
        foreach($data as $key=>$adata){
            $new_array[$key]['id'] =$key;
            $new_array[$key]['src'] = $adata['thumbnail'];
            $new_array[$key]['ActivityID'] = $adata['ActivityID'];
            $new_array[$key]['PhotoID'] =$adata['PhotoID'];
        }
    	if($data){
    		$response= array(
    			'status' => TRUE,
    			'account_photos' => $new_array,
    			'account_name' => $account_name  
    		);
    		echo json_encode($response);
    	}
    	else{
    		$response = array(
    			'status'=> FALSE,
    			'message'=> 'No data found'
    		);
    		echo json_encode($response);
    	}
    }
    public function allphotos(){

        $this->db->select('act.ActivityID,IFNULL(act.isEvent,0) as is_event,photos.thumbnail ');
        $this->db->from('ptsl_account_activity act');
        $this->db->join('ptsl_activity_photos photos','act.ActivityID=photos.ActivityID','');
        //$this->db->where('act.AccountID',$id);
        $this->db->where('photos.thumbnail!=""');
        $data = $this->db->get()->result_array();
        $new_array = array(); 
        foreach($data as $key=>$adata){
            $new_array[$key]['id'] =$key;
            $new_array[$key]['src'] = $adata['thumbnail'];
            $new_array[$key]['ActivityID'] = $adata['ActivityID'];
            $new_array[$key]['is_event'] =$adata['is_event'];
            if($adata['is_event'] == 1){
                $new_array[$key]['url'] = "#/eventdetails/".$adata['ActivityID'];
            }
            else{
                $new_array[$key]['url'] = "#/activitydetails/".$adata['ActivityID'];
            }
        }
        if($data){
            $response= array(
                'status' => TRUE,
                'all_photos' => $new_array  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    public function getPhotos($photoid){
        $this->db->select('p.Photo');
        //$this->db->where('PhotoID',$photoid);
        $this->db->from('ptsl_activity_photos p');
        $this->db->join('ptsl_account_activity a','p.ActivityID=a.ActivityID','');
       // $this->db->where('a.AccountID',$id);
        $this->db->where('PhotoID',$photoid);
        $this->db->where('p.thumbnail!=""');
        $data = $this->db->get()->result_array();
        if($data){
          $response= array(
                'status' => TRUE,
                'photos' => $data[0]['Photo']  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
    public function getPhotosid($id){
        $this->db->select('p.PhotoID');
        //$this->db->where('PhotoID',$photoid);
        $this->db->from('ptsl_activity_photos p');
        $this->db->join('ptsl_account_activity a','p.ActivityID=a.ActivityID','');
        $this->db->where('a.AccountID',$id);
        $this->db->where('p.thumbnail!=""');
        $data = $this->db->get()->result_array();
        if($data){
          $response= array(
                'status' => TRUE,
                'photos_id' => $data  
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }
	private function ak_img_thumb($target, $newcopy, $w, $h, $ext) {
	    list($w_orig, $h_orig) = getimagesize($target);
	    $src_x = ($w_orig / 2) - ($w / 2);
	    $src_y = ($h_orig / 2) - ($h / 2);
	    $ext = strtolower($ext);
	    $img = "";
	    if ($ext == "gif"){ 
	    $img = imagecreatefromgif($target);
	    } else if($ext =="png"){ 
	    $img = imagecreatefrompng($target);
	    } else { 
	    $img = imagecreatefromjpeg($target);
	    }
	    $tci = imagecreatetruecolor($w, $h);
	    //imagecopyresampled($tci, $img, 0, 0, $src_x, $src_y, $w, $h, $w_orig, $h_orig);
	    imagecopyresampled($tci, $img, 0, 0, 0, 0, $w, $h, $w_orig, $h_orig);
	    if ($ext == "gif"){ 
	        imagegif($tci, $newcopy);
	    } else if($ext =="png"){ 
	        imagepng($tci, $newcopy);
	    } else { 
	       $t= imagejpeg($tci, $newcopy, 84);
	       //echo base64_encode($t);

	    }
	   //echo base64_encode($target);
	}
    public function makejpg(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        //print_r($post_data); 
        $image =$post_data['image'];
        $loc="../accountapi_dev/email_photos/";

        $imgData1 = $image;
        $imgData1 = substr($imgData1, 1+strrpos($imgData1, ','));
      //  echo $imgData1;
       // $sourceFilename = 'http://periscopedemo.com/accountapi_dev/temp/imgMyFile.jpg';
        $image_file=date('YmdHis').'MyFile.jpg';
        $tes = file_put_contents($loc.$image_file, base64_decode($imgData1));
        //echo $tes;
        if($image_file){
            $response= array(
                'status' => TRUE,
                'photo' =>  "http://periscopedemo.com/accountapi_dev/email_photos/".$image_file 
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status'=> FALSE,
                'message'=> 'No data found'
            );
            echo json_encode($response);
        }
    }

}