<?php

defined('BASEPATH') OR exit('No direct script access allowed');

header('Access-Control-Allow-Origin: *'); 

class Auth extends CI_Controller {

	public function __construct() 

    {

        parent::__construct();

        

    }

	

	public function login(){

		$errors = array();

		$data = array();

		

		$post_data = json_decode(file_get_contents('php://input'), true);

		

		if (empty($post_data['username']))

			$errors['username'] = 'Username is required.';

		if (empty($post_data['password']))

			$errors['password'] = 'Password is required.';

		if($errors){

			$response = array(

					'status' => FALSE,

					'message' => 'Username and Password is required' 

				);

			echo json_encode($response);

			return;	 

		}

		$this->db->select('*');

		$this->db->where('ClientRepLoginName',$post_data['username']);	 

		$this->db->where('Password',($post_data['password']));

		$this->db->where('isActive','1');

		$data = $this->db->get('ptsl_clientrep')->result_array();

		if($data){
			$this->db->select('id,config_name,config_value');
			$config_data = $this->db->get('ptsl_config')->result_array();
			$response = array(

					'status'=> TRUE,

					'message'=> 'Login successful',

					'userid'=>$data[0]['ClientRepID'],
					'config_id'=> $config_data[0]['id'],
					'image_quality_config'=> $config_data[0]['config_name'],
					'image_quality_value'=> $config_data[0]['config_value']

				);

		}

		else{

			$response = array(

					'status'=> FALSE,

					'message'=> 'Login Failed'

				);

		}

		echo json_encode($response);

	}

	public function logout(){

		$this->session->unset_userdata('userdata');

		$this->session->sess_destroy();

		redirect(base_url());

	} 

}