<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Engage extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();
        
    }
    public function index(){
    	$this->db->where('isactive',1);
    	$result = $this->db->get('ptsl_engagementconfig')->result_array();
    	if($result){
             $response = array(
                'status' => TRUE,
                'engagements' => $result
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        	echo json_encode($response);
        }
    }
    public function pending(){
        /*$this->db->select('acc.LongName,eng.value,todo.id,date_format(todo.initiationdate,"%a, %M %d, %Y") as date');
        $this->db->from('ptsl_account_todolist todo');
        $this->db->join('ptsl_accountinfo acc','acc.AccountID=todo.accountid','');
        $this->db->join('ptsl_engagementconfig eng','eng.engagementid=todo.engagementid');
    	$this->db->where('todo.iscompleted',0);

        //$this->db->order_by('');
    	$result = $this->db->get()->result_array();*/
        $sql='SELECT `acc`.`LongName`, `eng`.`value`, `todo`.`id`, date_format(todo.initiationdate, "%a, %M %d, %Y") as date FROM `ptsl_account_todolist` `todo` JOIN `ptsl_accountinfo` `acc` ON `acc`.`AccountID`=`todo`.`accountid` JOIN `ptsl_engagementconfig` `eng` ON `eng`.`engagementid`=`todo`.`engagementid` WHERE `todo`.`iscompleted` =0';
        $result = $this->db->query($sql)->result_array();
    	if($result){
             $response = array(
                'status' => TRUE,
                'pending_todo' => $result
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        	echo json_encode($response);
        }
    }
    public function completed(){
    	/*$this->db->select('acc.LongName,eng.value,todo.id,date_format(todo.completiondate,"%a, %M %d, %Y") as cdate,date_format(todo.initiationdate,"%a, %M %d, %Y") as idate');
        $this->db->from('ptsl_account_todolist todo');
        $this->db->join('ptsl_accountinfo acc','acc.AccountID=todo.accountid','');
        $this->db->join('ptsl_engagementconfig eng','eng.engagementid=todo.engagementid');
        $this->db->where('todo.iscompleted',1);
        $result = $this->db->get()->result_array();*/
        $sql='SELECT `acc`.`LongName`, `eng`.`value`, `todo`.`id`, date_format(todo.initiationdate, "%a, %M %d, %Y") as idate,date_format(todo.completiondate,"%a, %M %d, %Y") as cdate FROM `ptsl_account_todolist` `todo` JOIN `ptsl_accountinfo` `acc` ON `acc`.`AccountID`=`todo`.`accountid` JOIN `ptsl_engagementconfig` `eng` ON `eng`.`engagementid`=`todo`.`engagementid` WHERE `todo`.`iscompleted` =1';
        $result = $this->db->query($sql)->result_array();
    	if($result){
             $response = array(
                'status' => TRUE,
                'completed_todo' => $result
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        	echo json_encode($response);
        }
    }
    public function changestatus($id){
        $data= array(
            'iscompleted' =>1,
            'completiondate'=> date('Y-m-d')
        );
        $this->db->where('id',$id);
        $res = $this->db->update('ptsl_account_todolist',$data);
        if($res){
            $response = array(
                'status' => TRUE,
                'message' => 'Success'
            );
            echo json_encode($response);
        }
    }
     /*public function pending(){
     	
    	$this->db->where('iscompleted',1);
    	$result = $this->db->get('ptsl_account_todolist')->result_array();
    	if($result){
             $response = array(
                'status' => TRUE,
                'pending_todo' => $result
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        	echo json_encode($response);
        }
    }*/
    public function add(){
        $post_data = json_decode(file_get_contents('php://input'), true);
     //   print_r($post_data);
        $ids = $post_data['ids'];
        $user_id = $post_data['user_id'];
        $client_id = $post_data['repid'];

        if($ids){
            foreach ($ids as $id) {
                $data = array(
                    'accountid' => $client_id,
                    'engagementid' => $id,
                    'iscompleted' => 0,
                    'initiationdate' => date('Y-m-d'),
                    
                    'clientrepid' => $user_id
                );
                //print_r($data);exit;
                $res= $this->db->insert('ptsl_account_todolist',$data);
              //  echo $this->db->last_query(); exit;
            }
            $response = array(
                'status' => TRUE,
                'message' => "Data inserted"
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => False,
                'message' => "Please select atleast one option"
            );
            echo json_encode($response);
        }
    }
}