<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Recent_acitivity extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();  
    }

    public function index(){
    	/*$this->db->select('accinfo.LongName,activity.ActivityID,date_format(activity.CreatedDate,"%M %d , %Y") as date,activity.isEvent,subtype.SubtypeName');
    	$this->db->from('ptsl_account_activity activity');
    	$this->db->join('ptsl_activitysubtype subtype','subtype.ActivitySubtypeID = activity.ptsl_activitySubtype_ActivitySubtypeID','');
    	$this->db->join('ptsl_accountinfo accinfo','accinfo.AccountID = activity.AccountID','');
    	$this->db->join('ptsl_clientrep rep','rep.ClientRepID = activity.Client_Rep_ID','');
    	$data = $this->db->get()->result_array();*/
    	$sql ="SELECT * FROM `ptsl_account_activity` `activity` JOIN `ptsl_activitysubtype` `subtype` ON `subtype`.`ActivitySubtypeID` = `activity`.`ptsl_activitySubtype_ActivitySubtypeID` JOIN `ptsl_accountinfo` `accinfo` ON `accinfo`.`AccountID` = `activity`.`AccountID` JOIN `ptsl_clientrep` `rep` ON `rep`.`ClientRepID` = `activity`.`Client_Rep_ID`";
    	$data = $this->db->query($sql)->result_array();
    	if($data){
    		$response = array(
    			'status' => TRUE,
    			'recent_activities' => $data
    		);
    		echo json_encode($response);
    	}
    	else{
    		$response = array(
    			'status' => FALSE,
    			'message' => 'No data Found'
    		);
    		echo json_encode($response);
    	}
    }
    public function account_activity_list($id){
           $sql = "select IFNULL(ac.isEvent,0) as ch_ev, a.ClientRepName,accinfo.Longname,ac.ActivityID,subtype.SubtypeName, date_format(ac.ActivityDate, '%M %d, %Y') as date from ptsl_account_activity ac LEFT  JOIN ptsl_clientrep a on a.ClientRepID = ac.Client_Rep_ID join ptsl_activitysubtype subtype on `subtype`.`ActivitySubtypeID` = `ac`.`ptsl_activitySubtype_ActivitySubtypeID`  join `ptsl_accountinfo` `accinfo` ON `accinfo`.`AccountID` = `ac`.`AccountID` where ac.AccountID='".$id."' order by ActivityDate DESC";
           $data =$this->db->query($sql)->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'recent_activities' => $data
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
    }
    public function filter9(){
    	$state = @$this->input->get('state');
        $region_name = @urldecode($this->input->get('region'));
        $rep = @$this->input->get('rep');
        $region ="";
        if($region_name){
            $this->db->where('regionname',$region_name);
            $data7 = $this->db->get('ptsl_region')->result_array();
            $region = $data7[0]['id'];
        }
        $data_mdate = $this->db->query('SELECT max(ActivityDate)  as mdate FROM ptsl_account_activity')->result_array();
        $max_date = $data_mdate[0]['mdate'];
       // echo $max_date; exit;
    	$sql = "select IFNULL(ac.isEvent,0) as ch_ev, a.ClientRepName,accinfo.Longname,ac.ActivityID,subtype.SubtypeName, date_format(ac.ActivityDate, '%M %d, %Y') as date from ptsl_account_activity ac LEFT  JOIN ptsl_clientrep a on a.ClientRepID = ac.Client_Rep_ID LEFT  JOIN ptsl_distributormanager b on b.ptsl_ClientRep_ClientRepID=a.ClientRepID LEFT JOIN ptsl_region r on r.id = b.regionid join ptsl_activitysubtype subtype on `subtype`.`ActivitySubtypeID` = `ac`.`ptsl_activitySubtype_ActivitySubtypeID` left join `ptsl_accountinfo` `accinfo` ON `accinfo`.`AccountID` = `ac`.`AccountID` where ActivityDate >= DATE('".$max_date."') - INTERVAL 7 DAY ";
    	if($region && $state && $rep){ //111
    		$sql = $sql.' and r.id='.$region.' and accinfo.state="'.$state.'" and a.ClientRepID='.$rep ;	
    	}
    	if($region && !$state && !$rep){ //100
    		$sql = $sql.' and r.id='.$region;
    	}
    	if($region && $state && !$rep){ //110
    		$sql = $sql.' and r.id='.$region.' and accinfo.state="'.$state.'"';
    	}
    	if($region && !$state && $rep){//101
    		$sql = $sql.' and a.ClientRepID='.$rep.' and r.id='.$region;
    	}
    	if(!$region && !$state && $rep){//001
    		$sql = $sql.' and a.ClientRepID='.$rep;
    	}
    	if(!$region && $state && $rep){//011
    		$sql = $sql.' and accinfo.state="'.$state.'" and a.ClientRepID='.$rep;
    	}
    	if(!$region && $state && !$rep){//010
    		$sql = $sql.' and accinfo.state="'.$state.'"';
    	}
        $sql= $sql.' order by ac.ActivityDate desc,ac.ActivityID desc';
    	$data =$this->db->query($sql)->result_array();
    	//echo $this->db->last_query(); exit;
    	//print_r($data);
    	if($data){
    		$response = array(
    			'status' => TRUE,
    			'recent_activities' => $data
    		);
    		echo json_encode($response);
    	}
    	else{
    		$response = array(
    			'status' => FALSE,
    			'message' => 'No data Found'
    		);
    		echo json_encode($response);
    	}
    }
    public function region(){
        $data = $this->db->get('ptsl_region')->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'region' => $data
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
    }
    public function representative(){
        $this->db->select('ClientRepID as id,ClientRepName as name');
        $data = $this->db->get('ptsl_clientrep')->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'users' => $data
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }
    }
    public function update(){
        $dates = $this->db->query('SELECT ActivityID, date(CreatedDate) as cd FROM `ptsl_account_activity`')->result_array();
        foreach ($dates as $key => $date) {
            echo $date['cd'];
            $data= array(
                'ActivityDate' => $date['cd']
            );
            $this->db->where('ActivityID',$date['ActivityID']);
            $this->db->update('ptsl_account_activity',$data);
        }
    }
}