<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Recent_sales extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();  
    }

    public function index(){
    	$state = @$this->input->get('state');
    	$region_name = @urldecode($this->input->get('region'));
    	$rep = @$this->input->get('rep');
        $region ="";
        if($region_name){
            $this->db->where('regionname',$region_name);
            $data7 = $this->db->get('ptsl_region')->result_array();
            $region = $data7[0]['id'];
        }
        $data_mdate = $this->db->query('SELECT max(raw_date)  as mdate FROM ptsl_sales_transactions')->result_array();
        $max_date = $data_mdate[0]['mdate'];
    	/*$this->db->select('tran.brand_and_packaging as sku,tran.raw_account_name as LongName,date_format(tran.raw_date,"%M %d, %Y") as date,rep.ClientRepName');
    	$this->db->from(' ptsl_sales_transactions tran');
    	$this->db->join('ptsl_clientrep rep','rep.ClientRepID= tran.client_rep_id','');
    	$data = $this->db->get()->result_array();*/
    	$sql = "SELECT `tran`.`brand_and_packaging` as `sku`,tran.units as unit,  `tran`.`raw_account_name` as `LongName`, date_format(tran.raw_date, '%M %d, %Y') as date, `rep`.`ClientRepName`
			FROM `ptsl_sales_transactions` `tran`
			JOIN `ptsl_clientrep` `rep` ON `rep`.`ClientRepID`= `tran`.`client_rep_id` where raw_date >= DATE('".$max_date."') - INTERVAL 7 DAY";
		if($region && $state && $rep){ //111
			$sql = $sql.' and tran.region='.$region.' and tran.raw_state="'.$state.'" and tran.client_rep_id='.$rep ;	
		}
		if($region && !$state && !$rep){ //100
			$sql = $sql.' and tran.region='.$region;
		}
		if($region && $state && !$rep){ //110
			$sql = $sql.' and tran.region='.$region.' and tran.raw_state="'.$state.'"';
		}
		if($region && !$state && $rep){//101
			$sql = $sql.' and tran.client_rep_id='.$rep.' and tran.region='.$region;
		}
		if(!$region && !$state && $rep){//001
			$sql = $sql.' and tran.client_rep_id='.$rep;
		}
		if(!$region && $state && $rep){//011
			$sql = $sql.' and tran.raw_state="'.$state.'" and tran.client_rep_id='.$rep;
		}
		if(!$region && $state && !$rep){//010
			$sql = $sql.' and tran.raw_state="'.$state.'"';
		}
        $sql = $sql.' order by tran.raw_date desc,tran.order_id desc ';	
    	$data = $this->db->query($sql)->result_array();
    	if($data){
    		$response = array(
    			'status' => TRUE,
    			'recent_sales' => $data
    		);
    		echo json_encode($response);
    	}
    	else{
    		$response = array(
    			'status' => FALSE,
    			'message' => 'No data Found'
    		);
    		echo json_encode($response);
    	}
    }

}